  PROGRAM

ULARGE_INTEGER GROUP,TYPE
LowDw       ULONG
HighDW      ULONG
             END

  MAP
ULIntToDec     PROCEDURE(*DECIMAL, *ULARGE_INTEGER)
      MODULE('WINAPI')
          GetLogicalDriveStrings(ULONG,*CSTRING),ULONG,PASCAL,RAW,NAME('GetLogicalDriveStringsA')
          GetDriveType(*CSTRING),ULONG,PASCAL,RAW,NAME('GetDriveTypeA')
          GetDiskFreeSpaceEx(*CSTRING,*ULARGE_INTEGER,*ULARGE_INTEGER,*ULARGE_INTEGER),BOOL,PASCAL,RAW,NAME('GetDiskFreeSpaceExA')
      END
  END

Loc:DriveQueue QUEUE
CurrentDrive STRING(5)
DriveType    STRING(20)
TotalSize    DECIMAL(21)
TotalFree    DECIMAL(21)
   END

Window WINDOW('List of Drives'),AT(,,316,197),FONT('Arial',8,COLOR:Black,FONT:regular,CHARSET:ANSI),GRAY, |
         DOUBLE
       LIST,AT(5,3,303,166),USE(?List1),VSCROLL,FORMAT('24L(1)|M~Drive~@s5@83L(1)|M~Drive Type~@s20@80R(1)|M~Total Size~@n21@20R(1)|M~By' &|
           'tes Free~@n21@'),FROM(Loc:DriveQueue)
       BUTTON('Close'),AT(114,176,45,14),USE(?Close)
     END

Loc:APIResult           LONG                                  !
Loc:ListOfLogicalDrives CSTRING(255) ! Looks like 'A:\<0>C:\<0><0>
Loc:StringStart         LONG                                  !
Loc:StringEnd           LONG                                  !
Loc:DriveCount          LONG                                  !
Loc:CurrentDriveLetter  CSTRING(5)                          !
Loc:DisplayDriveType    STRING(20)                            !
Loc:i64BytesAvailableThisUser      LIKE(ULARGE_INTEGER)
Loc:i64TotalNumberOfBytes          LIKE(ULARGE_INTEGER)
Loc:i64TotalNumberOfFreeBytes      LIKE(ULARGE_INTEGER)
Loc:BytesAvailableThisUser      DECIMAL(21)
Loc:TotalNumberOfBytes          DECIMAL(21)
Loc:TotalNumberOfFreeBytes      DECIMAL(21)


    CODE
    ! Get the list of drives
    Loc:APIResult = GetLogicalDriveStrings(SIZE(Loc:ListofLogicalDrives) - 1, Loc:ListofLogicalDrives)

    ! Handle Each Drive
    Loc:DriveCount = 0
    Loc:StringStart = 1
    Loop
       IF Loc:ListOfLogicalDrives [ Loc:StringStart : Loc:StringStart ] = '<0>' ! At end of Drive List
           BREAK
       END
       Loc:StringEnd = Loc:StringStart + 1
       Loop
           IF Loc:ListOfLogicalDrives [ Loc:StringEnd : Loc:StringEnd ] = '<0>' ! At end of current drive
               BREAK
           END
           Loc:StringEnd += 1
       END

       ! I now can grab the drive letter and path
       Loc:CurrentDriveLetter = Loc:ListOfLogicalDrives [ Loc:StringStart : Loc:StringEnd - 1 ]
       Loc:DriveCount += 1
       Loc:StringStart = Loc:StringEnd + 1


       ! Get the drive type
       Loc:APIResult = GetDriveType(Loc:CurrentDriveLetter)
       Case Loc:APIResult
          OF 0 ! DRIVE_UNKNOWN
              Loc:DisplayDriveType = 'Drive Unknown'
          OF 1 ! DRIVE_NO_ROOT_DIR
              Loc:DisplayDriveType = 'No root directory'
          OF 2 ! DRIVE_REMOVABLE
              Loc:DisplayDriveType = 'Removable'
          OF 3 ! DRIVE_FIXED
              Loc:DisplayDriveType = 'Fixed'
          OF 4 ! DRIVE_REMOTE
              Loc:DisplayDriveType = 'Remote'
          OF 5 ! DRIVE_CDROM
              Loc:DisplayDriveType = 'CD ROM'
          OF 6 ! DRIVE_RAMDISK
              Loc:DisplayDriveType = 'Ram Disk'
       END

       ! Get the disk space information
       Loc:APIResult = GetDiskFreeSpaceEx(Loc:CurrentDriveLetter, Loc:i64BytesAvailableThisUser, Loc:i64TotalNumberOfBytes, Loc:i64TotalNumberOfFreeBytes)
       IF Loc:APIResult = 0 ! Failed
           CLEAR(Loc:BytesAvailableThisUser)
           CLEAR(Loc:TotalNumberOfBytes)
           CLEAR(Loc:TotalNumberOfFreeBytes)
       ELSE
           ULIntToDec(Loc:BytesAvailableThisUser, Loc:i64BytesAvailableThisUser)
           ULIntToDec(Loc:TotalNumberOfBytes, Loc:i64TotalNumberOfBytes)
           ULIntToDec(Loc:TotalNumberOfFreeBytes, Loc:i64TotalNumberOfFreeBytes)
       END

       Loc:DriveQueue.CurrentDrive = Loc:CurrentDriveLetter
       Loc:DriveQueue.DriveType = Loc:DisplayDriveType
       Loc:DriveQueue.TotalSize = Loc:TotalNumberOfBytes
       Loc:DriveQueue.TotalFree = Loc:BytesAvailableThisUser
       ADD(Loc:DriveQueue)
    END

    OPEN(Window)

    ACCEPT
        CASE Field()
        OF ?Close
            POST(EVENT:CloseWindow)
        END
    END


ULIntToDec PROCEDURE(*DECIMAL dResult, *ULARGE_INTEGER I64)
Two_To_32 EQUATE(4294967296) ! 2 ^ 32
 CODE
 dResult = I64.HighDW * Two_To_32 + I64.LowDW
 RETURN